@echo off

rem GetTempPathName.bat
rem 2008-07-09
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal EnableDelayedExpansion

  set scriptDir=%~d0%~p0
  set scriptName=%~n0%~x0

  call SetNumberOfArguments.bat %*

  if %NumberOfArguments% lss 1 goto :usage
  if %NumberOfArguments% gtr 3 goto :usage

  set prefix=%~1
  set suffix=%~2
  set directory=%~3

  if "%suffix%" == "" set suffix=.tmp
  if "%directory%" == "" set directory=%temp%
  if not exist "%directory%" set directory=%~d0%~p0
  if "%directory%" == "" set directory=%~d0%~p0

:loop
  set pathName=%directory%\%prefix%_%random%%suffix%

  rem "mkdir" is atomic. So use it to handle the temp file creation.
  mkdir "%pathName%" > NUL 2>&1
  if %ERRORLEVEL% equ 1 goto :loop

  rd "%pathName%"
  type NUL > "%pathName%"
  echo %pathName%

  goto :end

:usage
  echo   Usage:   "%scriptName%" "prefix" ["suffix"] ["directory"] 1>&2

:end
