@echo off

rem GiveEveryoneFullPermissionToObject.bat
rem 2008-07-21
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal EnableDelayedExpansion

  set scriptPath=%~d0%~p0
  set scriptName=%~n0%~x0
  set path=%scriptPath%;%path%

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% equ 1 (
    call :changePermission %*
  ) else (
    call :usage
  )

  goto :end

:changePermission
  rem Following statement needs double-quote to handle '&'.
  set object="%~1"

  rem Not using parentheses to handle files names with
  rem parentheses in this if-else statement. Do not
  rem convert to parentheses.
  if exist %object% call :processObject %object%
  if not exist %object% echo %object% not found^^! 1>&2

  goto :EOF

:processObject
  rem Following statement needs double-quote to handle '&'.
  set object="%~1"

  echo Setting ACL on %object% . . .
  rem Variable already contains double-quotes. Leave double-quote off.
  rem Put the -on at the end to handle '&' in file name.
  call TCRAA.cmd SetACL.exe -ot file -actn ace -ace "n:everyone;p:full" -on %object%

  goto :EOF

:usage
  echo   Usage: "%scriptName%" "directory" 1>&2
  echo            or 1>&2
  echo          "%scriptName%" "file" 1>&2
  goto :EOF

:end
