@echo off

rem PublicAccessAllContent.bat
rem 2008-10-21
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal

  set scriptPath=%~d0%~p0
  set scriptName=%~n0%~x0
  set path=%scriptPath%;%path%

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% == 0 (
    call :usage
  ) else (
    call :loop %*
  )

  goto :end

:loop
  if ?%1? == ?? goto :EOF
  rem Following statement needs double-quote to handle '&'
  set spec="%~1"

  rem spec already contains double-quotes. Leave double-quote off.
  call SetVariableToOutput.bat IsDirectory.bat %spec%
  set result=%OutputVariable%

  rem spec already contains double-quotes. Leave double-quote off.
  if %result% == 1 call :processDir %spec%
  if %result% == 0 call :processFile %spec%

  shift
  goto :loop

:processDir
  rem Following statement needs double-quote to handle '&'.
  set spec="%~1"

  rem spec already contains double-quotes. Leave double-quote off.
  call PublicAccess.bat %spec%

  rem For some reason, the following two statements doesn't do anything
  rem even after permission has been granted with the prior line.
  rem for %%f in (%spec%\*) do call PublicAccess.bat "%%f"
  rem for /D %%d in (%spec%\*) do call PublicAccessAllContent.bat "%%d"

  rem Therefore, this script performs them in a new shell.
  cmd /c PublicAccessDirContent.cmd %spec%
  goto :EOF

:processFile
  rem Following statement needs double-quote to handle '&'.
  set spec="%~1"

  rem spec already contains double-quotes. Leave double-quote off.
  call PublicAccess %spec%
  goto :EOF

:usage
  echo   Usage: "%scriptName%" "file/dir 1" [ . . . "file/dir N" ] 1>&2
  goto :EOF

:end
