@echo off

rem GiveEveryoneFullPermission.bat
rem 2008-10-21
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal EnableDelayedExpansion

  set scriptPath=%~d0%~p0
  set path=%scriptPath%;%path%

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% equ 0 (
    call :usage
  ) else (
    call :loop %*
  )

  goto :end

:loop
  rem Following statement needs double-quote to handle '&'.
  set spec="%~1"

  rem Variable already contains double-quotes. Leave double-quote off.
  if %spec% == "" goto :EOF

  rem Variable already contains double-quotes. Leave double-quote off.
  call SetVariableToOutput.bat IsFileMask.bat %spec%
  if %OutputVariable% == 1 (
    for %%f in (%spec%) do call GiveEveryoneFullPermissionToObject.bat "%%f"
  ) else (
    rem Variable already contains double-quotes. Leave double-quote off.
    call GiveEveryoneFullPermissionToObject.bat %spec%
  )

  shift
  goto :loop

:usage
  echo   Usage: %~n0%~x0 "file/dir 1" [ . . . "file/dir N" ] 1>&2
  goto :EOF

:end
