@echo off

rem HasAdminPrivilege.cmd
rem Wed 12/03/2014
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL) Version 2, June 1991

  SetLocal EnableDelayedExpansion

  set scriptDir=%~d0%~p0
  set scriptName=%~n0%~x0

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% equ 0 (
    call :run %*
  ) else (
    call :usage
  )

  goto :end

:run
  rem Used to work, but no longer works.
  rem set caclsExec=%SystemRoot%\System32\icacls.exe
  rem if not exist "%caclsExec%" set caclsExec=%SystemRoot%\System32\cacls.exe
  rem >nul 2>&1 "%caclsExec%" "%SystemRoot%\system32\config\system"

  rem Not reliable. Windows 10 Pro and Windows 10 Home produce
  rem different results
  rem >nul 2>&1 dir "%SystemRoot%\system32\config\system"

  rem Works with Windows 10 Pro, Windows 10 Home, and Windows 7.
  >nul 2>&1 net session
  if %errorlevel% neq 0 (
    echo 0
  ) else (
    echo 1
  )
  goto :EOF

:usage
  echo   Usage:   "%scriptName%"
  goto :EOF

:end
