@echo off

rem TakeControl.bat
rem 2008-07-21
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal

  set scriptPath=%~d0%~p0
  set scriptName=%~n0%~x0
  set path=%scriptPath%;%path%

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% == 0 (
    call :usage
  ) else (
    call :loop %*
  )

  goto :end

:loop
  rem Following statement needs double-quote to handle '&'.
  set spec="%~1"

  rem spec already contains double-quotes. Leave double-quote off.
  if %spec% == "" goto :EOF

  echo Changing owner on %spec% . . .
  rem spec already contains double-quotes. Leave double-quote off.
  call TCRAA.cmd chown.exe %username% %spec%
  rem spec already contains double-quotes. Leave double-quote off.
  call GiveAdministratorsFullPermission.bat %spec%

  shift
  goto :loop

:usage
  echo   Usage: "%scriptName%" "file/dir 1" [ . . . "file/dir N" ] 1>&2
  goto :EOF

:end
